package org.starobjects.restful.viewer.authentication;

import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;

import org.nakedobjects.metamodel.authentication.AuthenticationSession;
import org.nakedobjects.runtime.authentication.AuthenticationRequestPassword;
import org.nakedobjects.runtime.authentication.standard.exploration.AuthenticationRequestExploration;
import org.nakedobjects.runtime.context.NakedObjectsContext;
import org.nakedobjects.runtime.system.DeploymentType;
import org.nakedobjects.webapp.auth.AuthenticationSessionLookupStrategyDefault;

public class AuthenticationSessionLookupStrategyExtended extends AuthenticationSessionLookupStrategyDefault {

	@Override
	public AuthenticationSession lookup(ServletRequest servletRequest,
			ServletResponse servletResponse) {
		AuthenticationSession session = super.lookup(servletRequest, servletResponse);
		if (session != null) {
			return session;
		}
		
        final DeploymentType deploymentType = NakedObjectsContext.getDeploymentType();

        if (deploymentType.isExploring()) {
        	AuthenticationRequestExploration request = new AuthenticationRequestExploration();
        	return NakedObjectsContext.getAuthenticationManager().authenticate(request);
        }

        HttpServletRequest httpServletRequest = (HttpServletRequest) servletRequest;
        String user = httpServletRequest.getParameter("user");
        String password = httpServletRequest.getParameter("password");
        
        if (user == null || password == null) {
        	return null;
        }
        AuthenticationRequestPassword request = new AuthenticationRequestPassword(user, password);
		return NakedObjectsContext.getAuthenticationManager().authenticate(request);
	}
}
