package org.starobjects.restful.viewer.embedded;

import org.jboss.resteasy.plugins.server.servlet.HttpServletDispatcher;
import org.jboss.resteasy.plugins.server.servlet.ResteasyBootstrap;
import org.nakedobjects.metamodel.commons.lang.MapUtils;
import org.nakedobjects.runtime.web.EmbeddedWebViewer;
import org.nakedobjects.runtime.web.WebAppSpecification;
import org.nakedobjects.webapp.NakedObjectsSessionFilter;
import org.nakedobjects.webapp.StaticContentFilter;
import org.nakedobjects.webapp.servlets.ResourceServlet;
import org.starobjects.restful.viewer.RestfulApplication;
import org.starobjects.restful.viewer.authentication.AuthenticationSessionLookupStrategyExtended;

final class EmbeddedWebViewerRestful extends EmbeddedWebViewer {
	@Override
	public WebAppSpecification getWebAppSpecification() {
	    WebAppSpecification webAppSpec = new WebAppSpecification();
	    
	    webAppSpec.addContextParams(
	    		RestfulViewerInstaller.JAVAX_WS_RS_APPLICATION, RestfulApplication.class.getName());
	    
	    webAppSpec.addServletContextListener(ResteasyBootstrap.class);
	    
	    webAppSpec.addFilterSpecification(
	    		NakedObjectsSessionFilter.class, 
	    		MapUtils.asMap(NakedObjectsSessionFilter.AUTHENTICATION_SESSION_LOOKUP_STRATEGY_KEY, AuthenticationSessionLookupStrategyExtended.class.getName()),
	    		RestfulViewerInstaller.EVERYTHING);
	    webAppSpec.addServletSpecification(
	    		HttpServletDispatcher.class, RestfulViewerInstaller.ROOT);
	    
	    webAppSpec.addFilterSpecification(
	    		StaticContentFilter.class, RestfulViewerInstaller.STATIC_CONTENT);
	    webAppSpec.addServletSpecification(
	    		ResourceServlet.class, RestfulViewerInstaller.STATIC_CONTENT );
	    
	    return webAppSpec;
	}
}