package org.starobjects.restful.viewer.embedded;

import org.nakedobjects.runtime.NakedObjects;
import org.nakedobjects.runtime.viewer.NakedObjectsViewer;
import org.nakedobjects.runtime.viewer.NakedObjectsViewerInstallerAbstract;
import org.nakedobjects.runtime.web.WebAppSpecification;

/**
 * Convenience implementation of a {@link NakedObjectsViewer} providing the
 * ability to configured for the Restful viewer from the {@link NakedObjects command line} using
 * <tt>--viewer org.starobjects.restful.viewer.embedded.RestfulViewerInstaller</tt> flag.
 * 
 * <p>
 * In a production deployment the configuration represented by the
 * {@link WebAppSpecification} would be specified in the <tt>web.xml<tt> file.
 */
public class RestfulViewerInstaller extends NakedObjectsViewerInstallerAbstract {

	static final String JAVAX_WS_RS_APPLICATION = "javax.ws.rs.Application";
	
	protected static final String EVERYTHING = "*";
	protected static final String ROOT = "/";
	protected static final String[] STATIC_CONTENT = new String[]{"*.js", "*.gif", "*.png"};

	public RestfulViewerInstaller() {
		super("restful");
	}
	
	@Override
	protected NakedObjectsViewer doCreateViewer() {
		return new EmbeddedWebViewerRestful();
	}
	
	

}
