package org.starobjects.restful.viewer.resources.objects;

import java.text.MessageFormat;

import nu.xom.Element;

import org.nakedobjects.metamodel.adapter.NakedObject;
import org.nakedobjects.metamodel.authentication.AuthenticationSession;
import org.nakedobjects.metamodel.spec.feature.NakedObjectAssociation;
import org.starobjects.restful.viewer.html.HtmlClass;
import org.starobjects.restful.viewer.xom.ResourceContext;


public final class TableColumnNakedObjectAssociationType<T extends NakedObjectAssociation> extends
        TableColumnNakedObjectAssociation<T> {

    public TableColumnNakedObjectAssociationType(
            final AuthenticationSession session,
            final NakedObject nakedObject,
            final ResourceContext resourceContext) {
        super("Type", session, nakedObject, resourceContext);
    }

    @Override
    public Element doTd(final T association) {
        final String assocTypeFullName = association.getSpecification().getFullName();
        final String uri = MessageFormat.format("{0}/specs/{1}", getContextPath(), assocTypeFullName);
        return xhtmlRenderer.aHref(uri, assocTypeFullName, "propertyTypeSpec", "property", HtmlClass.PROPERTY);
    }
}
