package org.starobjects.restful.viewer.resources.objects;


import org.nakedobjects.metamodel.adapter.NakedObject;
import org.nakedobjects.metamodel.authentication.AuthenticationSession;
import org.nakedobjects.metamodel.spec.feature.NakedObjectMember;
import org.starobjects.restful.viewer.xom.ResourceContext;
import org.starobjects.restful.viewer.xom.TableColumnAbstract;


public abstract class TableColumnNakedObjectMember<T extends NakedObjectMember> extends TableColumnAbstract<T> {

    private final NakedObject nakedObject;
    private final AuthenticationSession session;

    protected TableColumnNakedObjectMember(
            final String headerText,
            final AuthenticationSession session,
            final NakedObject nakedObject,
            final ResourceContext resourceContext) {
        super(headerText, resourceContext);
        this.nakedObject = nakedObject;
        this.session = session;
    }

    protected String getOidStr() {
        return getOidStr(getNakedObject());
    }

    public NakedObject getNakedObject() {
        return nakedObject;
    }

    public AuthenticationSession getSession() {
        return session;
    }

}
