package org.starobjects.restful.viewer.resources.objects;

import nu.xom.Element;

import org.nakedobjects.metamodel.adapter.NakedObject;
import org.nakedobjects.metamodel.authentication.AuthenticationSession;
import org.nakedobjects.metamodel.consent.Consent;
import org.nakedobjects.metamodel.spec.feature.NakedObjectMember;
import org.starobjects.restful.viewer.html.HtmlClass;
import org.starobjects.restful.viewer.xom.ResourceContext;


public final class TableColumnNakedObjectMemberDisabledReason<T extends NakedObjectMember> extends
        TableColumnNakedObjectMember<T> {

    public TableColumnNakedObjectMemberDisabledReason(
            final AuthenticationSession session,
            final NakedObject nakedObject,
            final ResourceContext resourceContext) {
        super("Disabled Reason", session, nakedObject, resourceContext);
    }

    @Override
    public Element doTd(final T property) {
        final Consent usable = property.isUsable(getSession(), getNakedObject());
        if (usable.isAllowed()) {
            return xhtmlRenderer.p(null, null);
        }

        return xhtmlRenderer.p(usable.getReason(), HtmlClass.USABLE);
    }
}
