package org.starobjects.restful.viewer.resources.objects;

import nu.xom.Element;

import org.nakedobjects.metamodel.adapter.NakedObject;
import org.nakedobjects.metamodel.authentication.AuthenticationSession;
import org.nakedobjects.metamodel.spec.feature.NakedObjectMember;
import org.starobjects.restful.viewer.html.HtmlClass;
import org.starobjects.restful.viewer.xom.ResourceContext;


public abstract class TableColumnNakedObjectMemberInvalidReason<T extends NakedObjectMember> extends
        TableColumnNakedObjectMember<T> {

    public TableColumnNakedObjectMemberInvalidReason(
            final AuthenticationSession session,
            final NakedObject nakedObject,
            final ResourceContext resourceContext) {
        super("Invalid Reason", session, nakedObject, resourceContext);
    }

    /**
     * Creates a &lt;p id=&quot;association-invalid-<i>associationId</i>&quot;/&gt; element so that Javascript
     * code can populate during validation.
     */
    @Override
    public Element doTd(final T member) {
        return builder().el("p").classAttr(HtmlClass.VALID).idAttr(getDomId(member)).build();
    }

    protected abstract String getDomId(T member);

}
