package org.starobjects.restful.viewer.resources.objects.actions;

import java.text.MessageFormat;

import nu.xom.Element;

import org.nakedobjects.metamodel.adapter.NakedObject;
import org.nakedobjects.metamodel.authentication.AuthenticationSession;
import org.nakedobjects.metamodel.spec.NakedObjectSpecification;
import org.nakedobjects.metamodel.spec.feature.NakedObjectAction;
import org.starobjects.restful.viewer.html.HtmlClass;
import org.starobjects.restful.viewer.resources.objects.TableColumnNakedObjectMemberName;
import org.starobjects.restful.viewer.xom.ResourceContext;


public class TableColumnNakedObjectActionName extends TableColumnNakedObjectMemberName<NakedObjectAction> {

    public TableColumnNakedObjectActionName(
            final NakedObjectSpecification noSpec,
            final AuthenticationSession session,
            final NakedObject nakedObject,
            final ResourceContext resourceContext) {
        super(noSpec, session, nakedObject, resourceContext);
    }

    @Override
    public Element doTd(final NakedObjectAction nakedObjectAction) {
        final String actionId = nakedObjectAction.getIdentifier().toNameParmsIdentityString();
        final String memberType = "action";
        final String uri = MessageFormat.format("{0}/specs/{1}/{2}/{3}", getContextPath(), getNoSpec().getFullName(), memberType, actionId);
        return new Element(xhtmlRenderer.aHref(uri, nakedObjectAction.getName(), "actionSpec", memberType, HtmlClass.ACTION));
    }

}
