package org.starobjects.restful.viewer.resources.objects.collections;

import java.text.MessageFormat;

import nu.xom.Element;

import org.nakedobjects.metamodel.adapter.NakedObject;
import org.nakedobjects.metamodel.authentication.AuthenticationSession;
import org.nakedobjects.metamodel.spec.feature.OneToManyAssociation;
import org.starobjects.restful.viewer.html.HtmlClass;
import org.starobjects.restful.viewer.resources.objects.TableColumnNakedObjectAssociation;
import org.starobjects.restful.viewer.xom.ResourceContext;


public final class TableColumnOneToManyAssociationAccess extends TableColumnNakedObjectAssociation<OneToManyAssociation> {

    public TableColumnOneToManyAssociationAccess(
            final AuthenticationSession session,
            final NakedObject nakedObject,
            final ResourceContext resourceContext) {
        super("Access", session, nakedObject, resourceContext);
    }

    @Override
    public Element doTd(final OneToManyAssociation collection) {
        if (!collection.isVisible(getSession(), getNakedObject()).isAllowed()) {
            return xhtmlRenderer.p(null, HtmlClass.PROPERTY);
        }

        final String contextPath = resourceContext.getHttpServletRequest().getContextPath();
        final String collectionId = collection.getId();
        final String uri = MessageFormat.format("{0}/object/{1}/collection/{2}", contextPath, getOidStr(), collectionId);
        return xhtmlRenderer.aHref(uri, collectionId, "collection", "nakedObject", HtmlClass.COLLECTION);
    }

}
