package org.starobjects.restful.viewer.resources.objects.collections;

import java.text.MessageFormat;

import nu.xom.Element;

import org.nakedobjects.metamodel.adapter.NakedObject;
import org.nakedobjects.metamodel.authentication.AuthenticationSession;
import org.nakedobjects.metamodel.spec.NakedObjectSpecification;
import org.nakedobjects.metamodel.spec.feature.OneToManyAssociation;
import org.starobjects.restful.viewer.html.HtmlClass;
import org.starobjects.restful.viewer.resources.objects.TableColumnNakedObjectMemberName;
import org.starobjects.restful.viewer.xom.ResourceContext;


public class TableColumnOneToManyAssociationName extends TableColumnNakedObjectMemberName<OneToManyAssociation> {

    public TableColumnOneToManyAssociationName(
            final NakedObjectSpecification noSpec,
            final AuthenticationSession session,
            final NakedObject nakedObject,
            final ResourceContext resourceContext) {
        super(noSpec, session, nakedObject, resourceContext);
    }

    @Override
    public Element doTd(final OneToManyAssociation oneToManyAssociation) {
        final String memberName = oneToManyAssociation.getIdentifier().getMemberName();
        final String memberType = "collection";
        final String uri = MessageFormat.format("{0}/specs/{1}/{2}/{3}", getContextPath(), getNoSpec().getFullName(), memberType,
                memberName);
        return new Element(xhtmlRenderer.aHref(uri, oneToManyAssociation.getName(), "propertySpec", memberType,
                HtmlClass.COLLECTION));
    }



}
