package org.starobjects.restful.viewer.resources.objects.properties;

import java.text.MessageFormat;

import nu.xom.Element;

import org.nakedobjects.metamodel.adapter.NakedObject;
import org.nakedobjects.metamodel.authentication.AuthenticationSession;
import org.nakedobjects.metamodel.spec.NakedObjectSpecification;
import org.nakedobjects.metamodel.spec.feature.OneToOneAssociation;
import org.starobjects.restful.viewer.html.HtmlClass;
import org.starobjects.restful.viewer.resources.objects.TableColumnNakedObjectMemberName;
import org.starobjects.restful.viewer.xom.ResourceContext;


public class TableColumnOneToOneAssociationName extends TableColumnNakedObjectMemberName<OneToOneAssociation> {

    public TableColumnOneToOneAssociationName(
            final NakedObjectSpecification noSpec,
            final AuthenticationSession session,
            final NakedObject nakedObject,
            final ResourceContext resourceContext) {
        super(noSpec, session, nakedObject, resourceContext);
    }

    @Override
    public Element doTd(final OneToOneAssociation oneToOneAssociation) {
        final String memberName = oneToOneAssociation.getIdentifier().getMemberName();
        final String memberType = "property";
        final String uri = MessageFormat.format("{0}/specs/{1}/{2}/{3}", getContextPath(), getNoSpec().getFullName(), memberType,
                memberName);
        return new Element(xhtmlRenderer.aHref(uri, oneToOneAssociation.getName(), "propertySpec", memberType, HtmlClass.PROPERTY));
    }


}
