package org.starobjects.restful.viewer.resources.objects.properties;

import nu.xom.Element;

import org.nakedobjects.metamodel.adapter.NakedObject;
import org.nakedobjects.metamodel.authentication.AuthenticationSession;
import org.nakedobjects.metamodel.facets.object.parseable.ParseableFacet;
import org.nakedobjects.metamodel.spec.feature.OneToOneAssociation;
import org.starobjects.restful.viewer.html.HtmlClass;
import org.starobjects.restful.viewer.resources.objects.TableColumnNakedObjectAssociation;
import org.starobjects.restful.viewer.xom.ResourceContext;


public final class TableColumnOneToOneAssociationParseable extends TableColumnNakedObjectAssociation<OneToOneAssociation> {

    public TableColumnOneToOneAssociationParseable(
            final AuthenticationSession session,
            final NakedObject nakedObject,
            final ResourceContext resourceContext) {
        super("Parseable", session, nakedObject, resourceContext);
    }

    @Override
    public Element doTd(final OneToOneAssociation property) {
        final boolean parseable = property.getFacet(ParseableFacet.class) != null;
        return xhtmlRenderer.p(parseable, HtmlClass.VISIBLE);
    }
}
