package org.starobjects.restful.viewer.util;

import java.util.ArrayList;
import java.util.List;

import org.nakedobjects.metamodel.runtimecontext.spec.feature.NakedObjectActionSet;
import org.nakedobjects.metamodel.spec.feature.NakedObjectAction;
import org.nakedobjects.metamodel.spec.feature.NakedObjectActionConstants;


public final class ActionUtils {

    private ActionUtils() {}

    public static NakedObjectAction[] flattened(final NakedObjectAction[] objectActions) {
        final List<NakedObjectAction> actions = new ArrayList<NakedObjectAction>();
        for (final NakedObjectAction action : objectActions) {
            if (action.getType() == NakedObjectActionConstants.SET) {
                final NakedObjectActionSet actionSet = (NakedObjectActionSet) action;
                final NakedObjectAction[] subActions = actionSet.getActions();
                for (final NakedObjectAction subAction : subActions) {
                    actions.add(subAction);
                }
            } else {
                actions.add(action);
            }
        }
        return actions.toArray(new NakedObjectAction[] {});
    }

}
