package org.starobjects.restful.viewer.util;

import org.nakedobjects.metamodel.adapter.NakedObject;
import org.nakedobjects.metamodel.adapter.oid.Oid;
import org.nakedobjects.metamodel.adapter.oid.stringable.OidStringifier;
import org.nakedobjects.runtime.context.NakedObjectsContext;
import org.nakedobjects.runtime.persistence.PersistenceSession;
import org.nakedobjects.runtime.persistence.adaptermanager.AdapterManager;

public final class OidUtils {
	
	
	private OidUtils(){}

	public static NakedObject getNakedObject(
			final String oidEncodedStr,
			final OidStringifier oidStringifier) {
		String oidStr = UrlDecoderUtils.urlDecode(oidEncodedStr);
		final Oid oid = oidStringifier.deString(oidStr);
	    return getAdapterManager().getAdapterFor(oid);
	}

	public static String getOidStr(
			final NakedObject nakedObject,
			final OidStringifier oidStringifier) {
		final Oid oid = nakedObject.getOid();
		return oid != null ? oidStringifier.enString(oid) : null;
	}
	
    ////////////////////////////////////////////////////////////////
    // Dependencies (from singletons)
    ////////////////////////////////////////////////////////////////
    
	public static AdapterManager getAdapterManager() {
		return getPersistenceSession().getAdapterManager();
	}

	protected static PersistenceSession getPersistenceSession() {
		return NakedObjectsContext.getPersistenceSession();
	}


}
